_, class = UnitClass("player")
if class == "MAGE" then

MCAuraEvents = {
["SPELL_AURA_APPLIED"] = true,
["SPELL_AURA_REMOVED"] = true,
["SPELL_AURA_APPLIED_DOSE"] = true,
["SPELL_AURA_REMOVED_DOSE"] = true,
["SPELL_AURA_REFRESH"] = true,
}

MCDamageEvents = {
["SPELL_DAMAGE"] = true,
["SWING_DAMAGE"] = true,
["RANGE_DAMAGE"] = true,
["SPELL_PERIODIC_DAMAGE"] = true,
["ENVIRONMENTAL_DAMAGE"] = true,
}

MCHealEvents = {
["SPELL_HEAL"] = true, 
["SPELL_PERIODIC_HEAL"] = true,
}

-- Interface\Icons\Spell_Arcane_Arcane03 invoker's energy /evocation = 12051/ buff = 116257
-- Interface\Icons\spell_mage_runeofpower 116011
-- Interface\Icons\spell_mage_infernoblast
-- Interface\Icons\Spell_Fire_SealOfFire combustion
-- Interface\Icons\Spell_Fire_Incinerate ignite
-- 130 slowfall
-- 111264 ice ward
-- 12654 ignite
-- 110909 alter time
-- Interface\Icons\Ability_Mage_LivingBomb
-- Interface\Icons\spell_mage_frostbomb
-- Interface\Icons\spell_mage_nethertempest
-- Interface\Icons\Ability_Mage_IncantersAbsorption 116267 buff / 1463 spell & shield

MCIgniteSpells = {
[108853] = true, -- inferno blast
[133] = true, -- fireball
[11366] = true, -- pyroblast
[2948] = true, -- scorch
[44614] = true, -- frostfire bolt
}

MCTimerList = {
[57761] = true,
[44544] = true,
[48107] = true,
[48108] = true,
[12042] = true,
[36032] = true,
[79683] = true,
[12472] = true,
[84714] = true,
[55342] = true,
[113724] = true,
[116257] = true,
[116267] = true,
}

MCmanabarflash = false
local changecolor, loaded, combustiondelay = 0, false, 0
MCcombustionmultiplier = 1
MCspec = ""

--Localization------------------------------------------

local locale = GetLocale()
if locale == "enUS" then
MageCandyLocal = MageCandyenUS
elseif locale == "deDE" then -- German
MageCandyLocal = MageCandydeDE
elseif locale == "enGB" then -- British English
MageCandyLocal = MageCandyenGB
elseif locale == "esES" then -- Spanish
MageCandyLocal = MageCandyesES
elseif locale == "esMX" then -- Spanish(Mexixo)
MageCandyLocal = MageCandyesMX
elseif locale == "frFR" then -- French
MageCandyLocal = MageCandyfrFR
elseif locale == "koKR" then -- Korean
MageCandyLocal = MageCandykoKR
elseif locale == "ruRU" then -- Russian
MageCandyLocal = MageCandyruRU
elseif locale == "zhCN" then -- Simplified Chinese
MageCandyLocal = MageCandyzhCN
elseif locale == "zhTW" then -- Traditional Chinese
MageCandyLocal = MageCandyzhTW
else
print("Localization Not Found")
MageCandyLocal = MageCandyenUS
end

----------------------------------------------------------

function MageCandy_MCTimerOnUpdate(self, elapsed)

if combustiondelay > 0 then
combustiondelay = combustiondelay - elapsed
if combustiondelay < 0 then
combustiondelay = 0
local starttime, duration = GetSpellCooldown(11129)
MCCombustionTrackerCooldown:SetCooldown(starttime, duration)
end
end

MageCandy_TrackersUpdate(elapsed)

if MCStats:IsShown() and MCtimerbypass == 0 then
MageCandy_UpdateStats()
end
if MCmanabarflash == true then
changecolor = changecolor + elapsed
if changecolor >= 1 then
changecolor = 0
MCManaBar:SetStatusBarColor(0.8, 0, 0)
elseif changecolor > 0.5 and changecolor < 1 then
MCManaBar:SetStatusBarColor(0, 0, 1)
elseif changecolor <= 0.5 then
MCManaBar:SetStatusBarColor(0.8, 0, 0)
end
else
changecolor = 0
MCManaBar:SetStatusBarColor(0, 0, 1)
end
MageCandy_NotificationsHandler(elapsed)

MageCandy_UpdateTimers(elapsed)

if MCtimerbypass > 0 then
MCtimerbypass = MCtimerbypass - elapsed
MCPolymorphMonitorBarText:SetText(string.sub(MCtimerbypass, 1, 4))
MCPolymorphMonitorBar:SetValue(MCtimerbypass)
if MCtimerbypass <= 0 then
MageCandy_LockFrames()
MCtimerbypass = 0
MCPolymorphMonitor:Hide()
MCPolymorphMonitorBar:SetValue(0)
MCPolymorphMonitorBarText:SetText(0)
MageCandy_HideFrames()
MageCandy_UpdateUI()
MCsave = MageCandy_Profiles[1].options
end
end

if MCSpellStealNotification:IsShown() and MCtimerbypass == 0 then
MageCandy_MCSpellStealNotificationUpdate(elapsed)
end

MageCandy_PolymorphUpdate(elapsed)

end


MageCandyEventFrame = CreateFrame("Frame", "MageCandyEventFrame", UIParent)
MageCandyEventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MageCandyEventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
MageCandyEventFrame:RegisterEvent("PLAYER_FOCUS_CHANGED")
MageCandyEventFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
MageCandyEventFrame:RegisterEvent("ADDON_LOADED")
MageCandyEventFrame:RegisterEvent("UNIT_AURA")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_APPLIED")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_REMOVED")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_APPLIED_DOSE")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_REMOVED_DOSE")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_BROKEN")
MageCandyEventFrame:RegisterEvent("SPELL_AURA_BROKEN_SPELL")
MageCandyEventFrame:RegisterEvent("COMPANION_UPDATE")
MageCandyEventFrame:RegisterEvent("UNIT_POWER_FREQUENT")
MageCandyEventFrame:RegisterEvent("UNIT_HEALTH_FREQUENT")
MageCandyEventFrame:RegisterEvent("PLAYER_ALIVE")
MageCandyEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MageCandyEventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
MageCandyEventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
MageCandyEventFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
MageCandyEventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")


function MageCandy_Round(number, decimals)
return tonumber((("%%.%df"):format(decimals)):format(number))
end


function MageCandy_OnEvent(self, event, ...)

local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16 = ...
if event == "UNIT_DEAD" then

end
if event == "ADDON_LOADED" and arg1 == "MageCandy" then
MageCandy_Check(true)
MageCandy_CreateUI()
MageCandy_CreateOptionsMenu()
MageCandy_UpdateProfile()
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile].clicked = true
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Highlight"]:Show()
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
MageCandy_Cancel() -- applies scaling & saved text into input boxes
MageCandy_TimerHandler()
MageCandy_UpdateUI()
loaded = true
print("|cff00dfff"..MageCandyLocal["SLASH"].."|r")
end
if event == "PLAYER_ENTERING_WORLD" then
MageCandy_PlaceFrames()
MageCandy_HealthBarUpdate()
MageCandy_ManaBarUpdate()
MageCandy_UpdateStats()
if GetSpecialization() == 1 then
MCspec = "Arcane"
elseif GetSpecialization() == 2 then
MCspec = "Fire"
elseif GetSpecialization() == 3 then
MCspec = "Frost"
end
MCcombustionmultiplier = 1
for idx = 1, NUM_GLYPH_SLOTS do
local available, glyphtype, glyphtooltipindex, spellid = GetGlyphSocketInfo(idx)
if spellid == 56368 then
MCcombustionmultiplier = 2
break
end
end
end

if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "ACTIVE_TALENT_GROUP_CHANGED" then
if GetSpecialization() == 1 then
MCspec = "Arcane"
elseif GetSpecialization() == 2 then
MCspec = "Fire"
elseif GetSpecialization() == 3 then
MCspec = "Frost"
end
MCcombustionmultiplier = 1
for idx = 1, NUM_GLYPH_SLOTS do
local available, glyphtype, glyphtooltipindex, spellid = GetGlyphSocketInfo(idx)
if spellid == 56368 then
MCcombustionmultiplier = 2
break
end
end
end

if MCtimerbypass == 0 then
if event == "PLAYER_TARGET_CHANGED" then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mccombustiontracker == 1 then
MageCandy_CombustionTrackerUpdate(UnitGUID("target"))
end
end

if #MCBombs > 0 then
for idx = 1, #MCBombs do
if MCBombs[idx].update then 
if MCBombs[idx].guid == UnitGUID("target") then
local duration, expirationtime = 0, 0
duration, expirationtime = MageCandy_ScanUnit("target", "debuff", "player", MCBombs[idx].bombid)
if duration ~= 0 and expirationtime ~= 0 then
MCBombs[idx].update = nil
MCBombs[idx].duration = duration
MCBombs[idx].timer = expirationtime - GetTime()
_G["MCBombBar"..idx]:SetMinMaxValues(0, duration)
end
end
end
end
end

if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mctargetspellstealframe ~= 0 and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 then
MageCandy_UpdateSpellStealAuras("target")
end

if MCnewpolyguid ~= nil and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablepolymorphmonitor ~= 0 then
if UnitGUID("target") == MCnewpolyguid then
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff("target", MCpolyspell)
if unitcaster == "player" then
name = UnitName("target")
MCpolyguid = MCnewpolyguid
MCnewpolyguid = nil
MCpolyduration = expirationtime - GetTime()
MCPolymorphMonitorIcon:SetTexture(icon)
MCPolymorphMonitorText:SetText(name)
MCPolymorphMonitorBar:SetMinMaxValues(0, expirationtime - GetTime())
end
end
end

end

if event == "UNIT_POWER_FREQUENT" and arg1 == "player" then
if arg2 == "MANA" then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.enablemanabar == 1 then
MageCandy_ManaBarUpdate()
end
end
end

if event == "UNIT_HEALTH_FREQUENT" and arg1 == "player" then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.enablehealthbar == 1 then
MageCandy_HealthBarUpdate()
end
end

if event == "PLAYER_FOCUS_CHANGED" then

if #MCBombs > 0 then 
for idx = 1, #MCBombs do
if MCBombs[idx].update then
if MCBombs[idx].guid == UnitGUID("focus") then
local duration, expirationtime = 0, 0
duration, expirationtime = MageCandy_ScanUnit("focus", "debuff", "player", MCBombs[idx].bombid)
if duration ~= 0 and expirationtime ~= 0 then
MCBombs[idx].update = nil
MCBombs[idx].duration = duration
MCBombs[idx].timer = expirationtime - GetTime()
_G["MCBombBar"..idx]:SetMinMaxValues(0, duration)
end
end
end
end
end

if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcfocusspellstealframe ~= 0 and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 then
MageCandy_UpdateSpellStealAuras("focus")
end

if MCnewpolyguid ~= nil and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablepolymorphmonitor ~= 0 then
if UnitGUID("focus") == MCnewpolyguid then
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff("focus", MCpolyspell)
if unitcaster == "player" then
name = UnitName("focus")
MCpolyguid = MCnewpolyguid
MCnewpolyguid = nil
MCpolyduration = expirationtime - GetTime()
MCPolymorphMonitorIcon:SetTexture(icon)
MCPolymorphMonitorText:SetText(name)
MCPolymorphMonitorBar:SetMinMaxValues(0, expirationtime - GetTime())
end
end
end

end

if event == "UPDATE_MOUSEOVER_UNIT" then
if #MCBombs > 0 then 

for idx = 1, #MCBombs do
if MCBombs[idx].update then
if MCBombs[idx].guid == UnitGUID("mouseover") then
local duration, expirationtime = 0, 0
duration, expirationtime = MageCandy_ScanUnit("mouseover", "debuff", "player", MCBombs[idx].bombid)
if duration ~= 0 and expirationtime ~= 0 then
MCBombs[idx].update = nil
MCBombs[idx].duration = duration
MCBombs[idx].timer = expirationtime - GetTime()
_G["MCBombBar"..idx]:SetMinMaxValues(0, duration)
end
end
end
end
end

if MCnewpolyguid ~= nil and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablepolymorphmonitor ~= 0 then
if UnitGUID("mouseover") == MCnewpolyguid then
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff("mouseover", MCpolyspell)
if unitcaster == "player" then
name = UnitName("mouseover")
MCpolyguid = MCnewpolyguid
MCnewpolyguid = nil
MCpolyduration = expirationtime - GetTime()
MCPolymorphMonitorIcon:SetTexture(icon)
MCPolymorphMonitorText:SetText(name)
MCPolymorphMonitorBar:SetMinMaxValues(0, expirationtime - GetTime())
end
end
end

end

if event == "UNIT_AURA" then
if arg1 == "target" or arg1 == "focus" or arg1 == "player" then
if arg1 == "player" then
MageCandy_TimerHandler()
MageCandy_UpdateStats()
end

if #MCStolenSpells ~= 0 and #MCStolenSpells ~= nil and MCstealing ~= nil and (arg1 == "player" and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcstolenspellsframe ~= 0) and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 then
MageCandy_UpdateSpellStealAuras(arg1)
elseif ((arg1 == "target" and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mctargetspellstealframe ~= 0) or (arg1 == "focus" and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcfocusspellstealframe ~= 0)) and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 then
MageCandy_UpdateSpellStealAuras(arg1)
elseif arg1 == "player" then
MageCandy_UpdateStolenInfo(arg1)
end
end
end

if event == "COMBAT_LOG_EVENT_UNFILTERED" then

if arg4 == UnitGUID("player") and arg2 == "SPELL_DAMAGE" and MCIgniteSpells[arg12] then

end

if arg2 == "SPELL_CAST_SUCCESS" and arg12 == 11129 then -- combustion
combustiondelay = 0.1
elseif arg2 == "SPELL_CAST_SUCCESS" then
if arg12 == 130 then -- slowfall
if UnitIsPlayer(arg9) and arg8 ~= UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.slowfallmessage == 1 then
SendChatMessage(MageCandy_Profiles[MageCandy_ActiveProfile].options.input.slowfallmessage, "WHISPER", nil, arg9) 
end
elseif arg12 == 111264 then -- ice ward
if UnitIsPlayer(arg9) and arg8 ~= UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.icewardmessage == 1 then
SendChatMessage(MageCandy_Profiles[MageCandy_ActiveProfile].options.input.icewardmessage, "WHISPER", nil, arg9)
end
end
end

if arg4 == UnitGUID("player") and arg12 == MCSpellID["Ignite"] then
if (arg2 == "SPELL_AURA_APPLIED" or arg2 == "SPELL_AURA_REFRESH") then
MageCandy_CombustionTrackerUpdate(arg8)
elseif arg2 == "SPELL_PERIODIC_DAMAGE" and arg8 == UnitGUID("target") then

elseif (arg2 == "SPELL_AURA_REMOVED" or arg2 == "SPELL_AURA_EXPIRED") and arg8 == UnitGUID("target") then
MCignitetick = 0
MCignitetimer = 0.01
end
end

if (arg4 == UnitGUID("player") or MageCandy_GetGUID(arg8, MCBombs) ~= 0) and (arg12 == MCBombs.livingbomb or arg12 == MCBombs.frostbomb or arg12 == MCBombs.nethertempest) then
MageCandy_BombTrackerUpdate(arg2, arg4, arg8, arg9, arg12, arg13)
end

if arg2 == "SPELL_SUMMON" and arg4 == UnitGUID("player") and arg13 == "Mirror Image" then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcmirrorimagetimer == 1 then
MageCandy_NewTime("MCMirrorImageTimer", 30, true)
end
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcmirrorimagetracker == 1 then
table.insert(MCMirrorImages, {guid = arg8, healthmax = floor(UnitHealthMax("player") * 0.1), health = MageCandy_Round(UnitHealthMax("player") * 0.1)})
MCMirrorImageTracker:Show()
MageCandy_MirrorImageTrackerUpdate(arg2, arg4, arg8, arg12, arg15)
else
MCMirrorImageTracker:Hide()
end
end

if (MCDamageEvents[arg2] or MCHealEvents[arg2]) and MageCandy_GetGUID(arg8, MCMirrorImages) ~= 0 and MageCandy_GetGUID(arg8, MCMirrorImages) == arg8 then
MageCandy_MirrorImageTrackerUpdate(arg2, arg4, arg8, arg12, arg15)
elseif arg2 == "UNIT_DIED" and MageCandy_GetGUID(arg8, MCMirrorImages) ~= 0 and MageCandy_GetGUID(arg8, MCMirrorImages) == arg8 then
MageCandy_MirrorImageTrackerUpdate(arg2, arg4, arg8, arg12, arg15)
end

if arg4 == UnitGUID("player") and arg12 == MCSpellID["MCCauterizeNotification"] then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mccauterizenotification == 1 and arg2 == "SPELL_AURA_APPLIED" then
MCCauterizeNotification:Show()
elseif arg2 == "SPELL_AURA_REMOVED" then
MCCauterizeNotification:Hide()
MCCauterizeNotification:SetScale(MageCandy_Profiles[MageCandy_ActiveProfile].options.scale.mccauterizenotification)
MCcauterize = 1
end
end

if arg2 == "SPELL_CAST_SUCCESS" and arg4 == UnitGUID("player") then
if arg12 == MCSpellID["MCFrozenOrbTimer"] then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcfrozenorbtimer == 1 then
MageCandy_NewTime("MCFrozenOrbTimer", 10, true)
end
elseif arg12 == MCSpellID["MCRingOfFrostTimer"] then
if MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcringoffrosttimer == 1 then
MageCandy_NewTime("MCRingOfFrostTimer", 10, true)
end
end
end


if arg2 == "SPELL_STOLEN" and arg4 == UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 then
MageCandy_SpellStolen(arg15, arg16)

elseif MCAuraEvents[arg2] then 

if arg8 == UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablespellstealmonitor ~= 0 and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.mcstolenspellsframe ~= 0 then
MageCandy_UpdateStolenSpells(arg2, arg13, GetTime())
end
if MCPolyList[arg12] and arg4 == UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablepolymorphmonitor ~= 0 then
MageCandy_PolyHandler(arg2, arg4, arg5, arg8, arg9, arg12, arg13)
end
end

if MCDamageEvents[arg2] and (arg8 == MCpolyguid or arg8 == MCnewpolyguid) and MCpolyapplied == true and MCpolybroken == false and MageCandy_Profiles[MageCandy_ActiveProfile].options.enablepolymorphmonitor ~= 0 then
MCpolybrokenevent = arg2
MCpolybroken = true
MCpolyduration = 0
MCpolyremove = true
if arg5 == nil then arg5 = MageCandyLocal["Unknown"] end
if arg13 == nil then arg13 = MageCandyLocal["Unknown"] end
MCpolyculprit = arg5
MCpolyculpritspell = arg13
end

end
if UnitAffectingCombat("player") == 1 and loaded == true then
MageCandy_UpdateUI(false)
MageCandy_LockFrames()
elseif loaded == true then
MageCandy_UnlockFrames()
if MageCandy_Profiles[MageCandy_ActiveProfile].options.hideframes == 1 then
MageCandy_UpdateUI(true)
end
end

end



function MageCandy_ShortNumber(num)
if num == 0 then
return num
elseif num > 0 and num < 0.1 then
if string.sub(num, 5, 5) ~= "" and string.sub(num, 5, 5) ~= nil then
return string.sub(num,4, 4).."."..string.sub(num, 5, 5)
else
return string.sub(num,4, 4)
end
elseif num >= 0 and num < 1 then
if string.sub(num, 5, 5) ~= nil and string.sub(num, 5, 5) ~= "" then
return string.sub(num, 3, 4).."."..string.sub(num, 5, 5)
elseif num == 0.1 or num == 0.2 or num == 0.3 or num == 0.4 or num == 0.5 or num == 0.6 or num == 0.7
or num == 0.8 or num == 0.9 then
num = string.sub(num, 3, 3).."0"
return num
else
return string.sub(num, 3, 4)
end
elseif num == 1 then
return 100
elseif num > 999 then
num = string.sub(num, 1, string.len(num) - 3)..","..string.sub(num, string.len(num) - 2, string.len(num))
return num
elseif num == nil then
return 0
else 
return num
end
end

function MageCandy_CondenseNumber(num)
local length = string.len(num)
if num < 1000 then
return num
elseif num >= 1000 and num < 1000000 then
num = string.sub(num, 1, length - 3).."k"
return num
elseif num >= 1000000 then
num = string.sub(num, 1, length - 6).."m"
return num
end
end


function MageCandy_ScanUnit(unit, bufftype, caster, id)
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid
if bufftype == "debuff" then
for idx = 1, 40 do
name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff(unit, idx)
if name == nil then break end
if spellid == id and unitcaster == caster then
if duration == nil then duration = 0 end
if expiration == nil then expiration = 0 end
return duration, expirationtime
end
end
else
return 0, 0
end
return 0, 0
end

-- And finally, set the event handler script
MageCandyEventFrame:SetScript("OnEvent", MageCandy_OnEvent)
end